﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim dt As New DataTable()
        Dim dc1 As New DataColumn("ID")
        Dim dc2 As New DataColumn("LongValue")
        dt.Columns.Add(dc1)
        dt.Columns.Add(dc2)
        For r As Integer = 1 To 10
            Dim dr As DataRow = dt.NewRow()
            dr(0) = r
            If r Mod 2 = 0 Then
                dr(1) = "123,456,123,456.2355"
            Else
                dr(1) = 1234.56
            End If
            dt.Rows.Add(dr)
        Next
        C1TrueDBGrid1.DataSource = dt
        C1TrueDBGrid1.Splits(0).DisplayColumns(1).AllowSizing = False
        C1TrueDBGrid1.Splits(0).DisplayColumns(1).OwnerDraw = True
    End Sub

    Private Sub C1TrueDBGrid1_OwnerDrawCell(ByVal sender As Object, ByVal e As C1.Win.C1TrueDBGrid.OwnerDrawCellEventArgs) Handles C1TrueDBGrid1.OwnerDrawCell
        e.Handled = True
        e.Graphics.FillRectangle(New SolidBrush(e.Style.BackColor), e.CellRect)
        Dim val As Object = C1TrueDBGrid1.Columns(e.Col).CellValue(e.Row)
        Dim size As SizeF = e.Graphics.MeasureString(val.ToString(), C1TrueDBGrid1.Splits(0).DisplayColumns(e.Col).Style.Font)
        Dim width As Integer = CInt(Math.Ceiling(size.Width))
        Dim cellwidth As Integer = e.CellRect.Width
        If width > cellwidth Then
            Dim r As Integer = 1
            Dim s As String = e.Text
            Dim ns As String = ""
            While width > cellwidth - 5
                ns = s.Substring(0, s.Length - r)
                size = e.Graphics.MeasureString(ns.ToString(), C1TrueDBGrid1.Splits(0).DisplayColumns(e.Col).Style.Font)
                width = CInt(Math.Ceiling(size.Width))
                r += 1
                s = ns
            End While
            ns = ns + "...."
            e.Graphics.DrawString(ns, e.Style.Font, New SolidBrush(Color.Black), New PointF(e.CellRect.X, e.CellRect.Y))
        Else
            e.Graphics.DrawString(e.Text, e.Style.Font, New SolidBrush(Color.Black), New PointF(e.CellRect.X, e.CellRect.Y))
        End If
    End Sub
End Class
